/*
 * Copyright (C) 2003 Jean-Philippe Hergott <hergott@free.fr>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <errno.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

/*
 * GtkWindow "xcave_window".
 * button_add clicked
 */
void
on_xcave_button_add_clicked (GtkButton * button,
		                     gpointer user_data)
{
	GtkCombo *reglist = NULL, *applist = NULL, *countryList = NULL, *ceplist = NULL;
	gchar tmpreg[region_size];
	gchar tmpCountry[country_size];
	gchar ach[purchaseDate_size];

    XCAVE_DEBUG_B;

	/*
	 * 2.2.6
	 */
        NbBottleDetail = 0;

	strncpy (tmpreg, "",region_size);
	strncpy (tmpCountry, "",country_size);

	if (window_detail_origine != BUTTON_RACK_ADD)
		window_detail_origine = BUTTON_ADD;
	
	/* 
	 * desactive window_xcave
	 */
	gtk_widget_set_sensitive(window_xcave, FALSE);
	
	window_detail = create_xcave_detail ();
	
	/*
	 * armememnt de trois signaux dont on souhaite conserver l'id pour un blocage
	 * ulterieur
	 */
	xcave_signal_connect();
	
	/*
	 * redimensionnement de la fenetre
	 */
	if ( strlen(WindowsDetailHeight) != 0 && strlen (WindowsDetailWidth) != 0 ) {
	   gtk_window_set_default_size (GTK_WINDOW (window_detail), atoi(WindowsDetailWidth), atoi(WindowsDetailHeight));
	}
	
	gtk_widget_show (window_detail);
	
	countryList = GTK_COMBO (lookup_widget (window_detail, "wineCountryList"));
	reglist  = GTK_COMBO (lookup_widget (window_detail, "vinreglist"));
	applist  = GTK_COMBO (lookup_widget (window_detail, "vinaplist"));
	ceplist  = GTK_COMBO (lookup_widget (window_detail, "vinceplist"));
	
	gtk_combo_set_popdown_strings (GTK_COMBO (countryList), list_country);
	gtk_combo_set_popdown_strings (GTK_COMBO (reglist),  list_region);
	gtk_combo_set_popdown_strings (GTK_COMBO (applist),  list_appellation);
	gtk_combo_set_popdown_strings (GTK_COMBO (lookup_widget (window_detail, "vinceplist")), list_cepage);
	
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (lookup_widget (window_detail, "spinbutton_purchase_qty")), (gfloat) 1);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (lookup_widget (window_detail, "spinbutton_drinking_qty")), (gfloat) 1);
	
	sprintf (ach, "%d", nowan);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (window_detail, "entry_purchase_year")),      (gchar *) ach);
	gtk_entry_set_text(GTK_ENTRY (lookup_widget (window_detail, "entry_drinking_year"))     ,(gchar *) ach);
	
	xcave_create_TreeList_purchase(); 
	
	xcave_create_TreeList_drinking();
	
	/* 
	 * for the stock - let's go
	 */
	xcave_createRack(window_detail, NULL);

    XCAVE_DEBUG_E;
}

/*
 * from TreeList a row is selected - doubleclick or button_modif -
 * list_stock_rowSelect contains pointer to wine informations row in list_stock
 * display of detail_window 
 */

void
on_xcave_display_modif (	Vin	*Vin_rowSelected)
{
	GList        *tmp_list_country_region     = NULL;
	GList        *tmp_list_region_appellation = NULL;
	
	Purchase     *tmpPurchase;
	GList        *tmp_list_purchase;
	GList        *list_country_screen;
	GList        *list_region_combo;
	GList        *list_appellation_combo;
	
	Drinking     *tmpDrinking;
	GList        *tmp_list_drinking;
	
	gchar         ach[purchaseDate_size];
	gchar         an[vintage_size], cons[potentielDeGarde_size];
	
	gint	      i;
  
    XCAVE_DEBUG_B;

	fixed=gdk_font_load("-misc-fixed-medium-*-*-*-10-*-*-*-*-*-*-*");

	/* initialisation du compteur 'Nombre de bouteille detail' */
	NbBottleDetail = 0;
	
	window_detail = create_xcave_detail ();
	
	/*
	 * redimensionnement de la fenetre
	 */
	if ( strlen(WindowsDetailHeight) != 0 && strlen (WindowsDetailWidth) != 0 ) {
	   gtk_window_set_default_size (GTK_WINDOW (window_detail),
					atoi(WindowsDetailWidth),
					atoi(WindowsDetailHeight));
	}
	
	gtk_widget_show_all (window_detail);
	
	xcave_detail_statusbar_v = lookup_widget (window_detail, "xcave_detail_statusbar");
	xcave_detail_statusbar_ctxtid = gtk_statusbar_get_context_id ((GtkStatusbar *)xcave_detail_statusbar_v, "default");
	xcave_detail_statusbar_id = 0;
	
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (window_detail, "vinnom")),       Vin_rowSelected->Nom);
	// general
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (window_detail, "vinprod")),      Vin_rowSelected->supplier);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (window_detail, "vinprodurl")),   Vin_rowSelected->wineMakerAdr);
	sprintf (an, "%d", Vin_rowSelected->vintage);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (window_detail, "vinan")),        (gchar *) an);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (window_detail, "vincoulentry")), Vin_rowSelected->color);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (window_detail, "vincepentry")),  Vin_rowSelected->Cepage);
	sprintf (cons, "%d", Vin_rowSelected->Conserv);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (window_detail, "vincons")),      (gchar *) cons);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (window_detail, "vintemp")),      Vin_rowSelected->temperatureDeDegustation);
	
	// stock
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (lookup_widget (window_detail, "spinbutton_purchase_qty")), (guint) Vin_rowSelected->qty);

	/* 
	 * for the stock - let's go
	 */
	xcave_createRack(window_detail, Vin_rowSelected->list_emplacement);

	// Purchase
	GtkWidget		*treeList_purchase;
	GtkListStore	*StoreList_purchase;
	GtkTreeIter 	pIter;
	
	xcave_create_TreeList_purchase();
	
	treeList_purchase    = lookup_widget (window_detail, "treelist_purchase");	
	StoreList_purchase   = (GtkListStore *) gtk_tree_view_get_model((GtkTreeView *)treeList_purchase);

	tmpPurchase = g_malloc (sizeof(Purchase));
	/*
	 * 2.2.6
	 * Pango-WARNING **: Invalid UTF-8 string passed to pango_layout_set_text()
	 */
	memset(tmpPurchase,'\0',sizeof(Purchase));
	
	for(tmp_list_purchase = Vin_rowSelected->list_purchase;
		tmp_list_purchase != NULL; 
		tmp_list_purchase = tmp_list_purchase->next) {

		memset(tmpPurchase,'\0',sizeof(Purchase));
		memcpy(tmpPurchase,tmp_list_purchase->data,sizeof(Purchase));

        gchar   tmpPrice[12];
        g_snprintf(tmpPrice,sizeof(tmpPrice),"%9.2f",tmpPurchase->Prix);

		gtk_list_store_append(StoreList_purchase, &pIter);
		gtk_list_store_set(StoreList_purchase, &pIter,
					COL_TREELIST_PURCHASE_DATE, (guint)tmpPurchase->Achat,
					COL_TREELIST_PURCHASE_QTY, (guint)tmpPurchase->qty,
					COL_TREELIST_PURCHASE_PRICE, &tmpPrice, 
					COL_TREELIST_SUPPLIER, &tmpPurchase->Supplier,
					COL_TREELIST_SUPPLIER_ADR, &tmpPurchase->SupplierAdr,
									-1);			

	   NbBottleDetail += tmpPurchase->qty;
	}
	g_free(tmpPurchase);

	g_object_unref(StoreList_purchase);

	gtk_spin_button_set_value (GTK_SPIN_BUTTON (lookup_widget (window_detail, "spinbutton_purchase_price")), (gfloat) 0);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (lookup_widget (window_detail, "spinbutton_purchase_qty")), (guint) 1);
	sprintf (ach, "%d", nowan);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (window_detail, "entry_purchase_year")),       (gchar *) ach);

	// drinking
	GtkWidget		*treeList_drinking;
	GtkListStore	*StoreList_drinking;

	xcave_create_TreeList_drinking();

	treeList_drinking = lookup_widget (window_detail, "treelist_drinking");	
	StoreList_drinking	= (GtkListStore *) gtk_tree_view_get_model((GtkTreeView *)treeList_drinking);

	tmpDrinking = g_malloc (sizeof(Drinking));
	
	for(tmp_list_drinking = Vin_rowSelected->list_drinking; 
		tmp_list_drinking != NULL; 
		tmp_list_drinking = tmp_list_drinking->next) {

                GdkPixbuf     *icon;
                GError        *error = NULL;

		memset(tmpDrinking,'\0',sizeof(Drinking));
		memcpy(tmpDrinking,tmp_list_drinking->data,sizeof(Drinking));

	        if (tmpDrinking->degustation_sheet_id != (time_t)0) 
	           icon = create_pixbuf("xcave_degustation.png");
	        else 
	           icon = gdk_pixbuf_new_from_file("", &error);
		gtk_list_store_append(StoreList_drinking, &pIter);
		gtk_list_store_set(StoreList_drinking, &pIter,
                                        COL_TREELIST_ICON,icon,
                                        COL_TREELIST_DRINKING_DATE, (guint)tmpDrinking->Conso,
                                        COL_TREELIST_DRINKING_QTY, (guint)tmpDrinking->qty,
                                        COL_TREELIST_NOTE, tmpDrinking->Note,
                                        COL_TREELIST_COMMENTAIRE, tmpDrinking->Commentaire,
                                        COL_TREELIST_SHEET_ID,tmpDrinking->degustation_sheet_id,
                                        -1);			

	   NbBottleDetail -= tmpDrinking->qty;
	   // NbBottleStock  -= tmpDrinking->qty;
	}

	g_free(tmpDrinking);
	g_object_unref(StoreList_drinking);

	gtk_entry_set_text (GTK_ENTRY (lookup_widget (window_detail, "entry_drinking_year")),       (gchar *) ach);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (lookup_widget (window_detail, "spinbutton_drinking_qty")), (guint) 1);

	sprintf (xcave_detail_statusbar_txt, _("Number of bottles for the selection : %d"), NbBottleDetail);
	// gestion du nombre de bouteille pour le vin selectionné 
	if (xcave_detail_statusbar_id != 0) gtk_statusbar_remove ((GtkStatusbar *)xcave_detail_statusbar_v, xcave_detail_statusbar_ctxtid, xcave_detail_statusbar_id);
	xcave_detail_statusbar_id = gtk_statusbar_push ((GtkStatusbar *)xcave_detail_statusbar_v, xcave_detail_statusbar_ctxtid, xcave_detail_statusbar_txt);
	
	// commentaire
	GtkWidget		*vincom;
	GtkTextBuffer	*buffer_vincom;
	
	vincom 	= lookup_widget (window_detail, "vincom");
	buffer_vincom = gtk_text_view_get_buffer (GTK_TEXT_VIEW (vincom));/* C */
	
       /*
	* commentaire. Remplacement de tout les carateres ² par <CR> avant affichage.
	* le caractere <CR> indique un fin d'enregistrement dans un fichier stream.
	*/
	for ( i=0 ; i < (comment_size - 1) ; i++) 
		if (strncmp(&Vin_rowSelected->Commentaire[i], "²",1) == 0) 
			strncpy(&Vin_rowSelected->Commentaire[i],"\n",1);

 	gtk_text_buffer_set_text (buffer_vincom, Vin_rowSelected->Commentaire, -1);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (window_detail, "vinnote")), Vin_rowSelected->Note);
					
	/* PAYS */
	list_country_screen = g_list_copy(list_country);
	if (list_country_screen != NULL)
		gtk_combo_set_popdown_strings (GTK_COMBO (lookup_widget (window_detail, "wineCountryList")), 
										list_country_screen);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (window_detail, "wineCountryEntry")), 
						Vin_rowSelected->country);

	/* REGION */
	list_region_combo = NULL;
	for(tmp_list_country_region = list_country_region; 
		tmp_list_country_region != NULL; 
		tmp_list_country_region = tmp_list_country_region->next) {
		  if (strcasecmp(tmp_list_country_region->data, Vin_rowSelected->country) == 0) 
		  list_region_combo = g_list_append(list_region_combo,tmp_list_country_region->data + country_size);
	}
	if (g_list_length(list_region_combo) == 0)
		list_region_combo = g_list_append(list_region_combo,"");

	gtk_combo_set_popdown_strings (GTK_COMBO (lookup_widget (window_detail, "vinreglist")), list_region_combo);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (window_detail, "vinregentry")), Vin_rowSelected->Region);

	/* APPELLATION / TERROIR */
	list_appellation_combo = NULL;
	for(tmp_list_region_appellation = list_region_appellation; 
		tmp_list_region_appellation != NULL; 
		tmp_list_region_appellation = tmp_list_region_appellation->next) {
		/*
		  if (( strcasecmp(tmp_list_region_appellation->data, Vin_rowSelected->Region) == 0)
			  ||
			 ( strcasecmp(tmp_list_region_appellation->data, Vin_rowSelected->country) == 0)
		  )
		 */
	  if ( strcasecmp(tmp_list_region_appellation->data, Vin_rowSelected->Region) == 0)
		list_appellation_combo = g_list_append(list_appellation_combo,tmp_list_region_appellation->data + region_size);
	}

	if (g_list_length(list_appellation_combo) == 0) 
		list_appellation_combo = g_list_append(list_appellation_combo,"");

	gtk_combo_set_popdown_strings (GTK_COMBO (lookup_widget (window_detail, "vinaplist")), list_appellation);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (window_detail, "vinapentry")), Vin_rowSelected->Appellation);

	/* CEPAGE
	 */
	if (list_cepage != NULL)
		gtk_combo_set_popdown_strings (GTK_COMBO (lookup_widget (window_detail, "vinceplist")), list_cepage);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (window_detail, "vincepentry")), Vin_rowSelected->Cepage);
	
	/*
	 * armememnt de trois signaux dont on souhaite conserver l'id pour un blocage
	 * ulterieur
	 */
	xcave_signal_connect();

    XCAVE_DEBUG_E;
}

void
on_xcave_button_modif_clicked  (GtkButton       *button,
                                gpointer         user_data)
{
  
	Vin			  *Vin_rowSelected;

    XCAVE_DEBUG_B;

	/*
	 * we need selected data 
	 */
	Vin_rowSelected = xcave_id_selected_treelist_row();

	if (Vin_rowSelected != NULL) {
		/* 
		 * desactive window_xcave
		 */
		gtk_widget_set_sensitive(window_xcave, FALSE);
	
		window_detail_origine = BUTTON_MODIF;
	
		on_xcave_display_modif(Vin_rowSelected);
	}

    XCAVE_DEBUG_E;
}

/*
 *	
 *
 */
void
on_xcave_detail_button_ok_clicked (GtkButton * button,
									gpointer user_data)
{
	Vin          	*tmpVin;
	Vin             *Vin_rowSelected;
	ptrCateg        ptmpCtg;

    XCAVE_DEBUG_B;

	tmpVin = g_malloc ( sizeof(Vin) );
	memset(tmpVin, '\0', sizeof( Vin ));

	strcpy (tmpVin->Nom, gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "vinnom"))));

	/* get data from vpaned 'general' */
	strcpy (tmpVin->supplier, gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "vinprod"))));
	strcpy (tmpVin->wineMakerAdr,	gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "vinprodurl"))));
	tmpVin->vintage = atoi (gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "vinan"))));
	strcpy (tmpVin->color, gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "vincoulentry"))));
	strcpy (tmpVin->country, gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "wineCountryEntry"))));
	strcpy (tmpVin->Region, gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "vinregentry"))));
	strcpy (tmpVin->Appellation, gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "vinapentry"))));
	strcpy (tmpVin->Cepage, gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "vincepentry"))));
	tmpVin->Conserv   = atoi (gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "vincons"))));
	strcpy (tmpVin->temperatureDeDegustation, gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "vintemp"))));
	
	/*
	 * get data from vpaned 'racks'
	 */
	tmpVin->qty = 0;
	/*
	 * on supprime l(es) emplacements en cas de duplication
	 * -> bug si l'utilisateur a modifie l emplacement !
	 */
	if (window_detail_origine != BUTTON_DUPLICATE)
		tmpVin->list_emplacement = xcave_rackTreatment(tmpVin->Nom);
	
	/*
	 * get data from vpaned 'purchase'
	 */
	GtkWidget		*TreeList_purchase;
	GtkTreeModel	*treelist_purchase_model;
	GtkTreeIter 	treelist_iter;
	gboolean		btreelist = TRUE;
	Purchase		*tmp_purchase;
	
	TreeList_purchase = lookup_widget(window_detail,"treelist_purchase");
	treelist_purchase_model	= gtk_tree_view_get_model((GtkTreeView *)TreeList_purchase);

	btreelist = gtk_tree_model_get_iter_first(treelist_purchase_model,/* C */
											  &treelist_iter);
	   												
	while (btreelist == TRUE) {
		gchar	*pSupplier;
		gchar	*pSupplierAdr;
		gchar	*pPrice;
	
		tmp_purchase = g_malloc(sizeof(Purchase));
		pSupplier = g_malloc(supplier_size);
		pSupplierAdr = g_malloc(supplierAdr_size);
		pPrice = g_malloc(price_size);
	        /*
	         * 2.2.6
        	 * Pango-WARNING **: Invalid UTF-8 string passed to pango_layout_set_text()
        	 */
        memset(tmp_purchase,'\0',sizeof(Purchase));
		memset(pSupplier,'\0',supplier_size);
		memset(pSupplierAdr,'\0',supplierAdr_size);
		memset(pPrice,'\0',price_size);
	
		gtk_tree_model_get (treelist_purchase_model, &treelist_iter,
							COL_TREELIST_PURCHASE_DATE, &tmp_purchase->Achat,
							COL_TREELIST_PURCHASE_QTY, &tmp_purchase->qty,
							COL_TREELIST_PURCHASE_PRICE, &pPrice,
							COL_TREELIST_SUPPLIER, &pSupplier,
							COL_TREELIST_SUPPLIER_ADR, &pSupplierAdr,
							-1);
	
		strcpy(tmp_purchase->Supplier,pSupplier);
		strcpy(tmp_purchase->SupplierAdr,pSupplierAdr);
		tmp_purchase->Prix = atof(pPrice);
		g_free(pSupplier);
		g_free(pSupplierAdr);
		g_free(pPrice);
		
		tmpVin->list_purchase = g_list_append(tmpVin->list_purchase, tmp_purchase);
	
		btreelist = gtk_tree_model_iter_next(treelist_purchase_model,
                                             &treelist_iter);
		tmpVin->qty += tmp_purchase->qty;
	}
											  
	/*
	 * get data from vpaned 'drinking'
	 */
	GtkWidget		*TreeList_drinking;
	GtkTreeModel	*treelist_drinking_model;
	Drinking		*tmp_drinking;

	TreeList_drinking = lookup_widget(window_detail,"treelist_drinking");
	treelist_drinking_model	= gtk_tree_view_get_model((GtkTreeView *)TreeList_drinking);

	btreelist = gtk_tree_model_get_iter_first(treelist_drinking_model, &treelist_iter);
	
	while (btreelist == TRUE) {

		gchar	*pNote;
		gchar	*pCommentaire;
	
		pNote = g_malloc(rated_size);
		pCommentaire = g_malloc(comment_size);
		tmp_drinking = g_malloc(sizeof(Drinking));
	    memset(tmp_drinking, '\0', sizeof( Drinking ));
	
		gtk_tree_model_get (treelist_drinking_model, &treelist_iter,
                                    COL_TREELIST_DRINKING_DATE, &tmp_drinking->Conso,
                                    COL_TREELIST_DRINKING_QTY, &tmp_drinking->qty,
                                    COL_TREELIST_NOTE, &pNote,
                                    COL_TREELIST_COMMENTAIRE, &pCommentaire,
                                    COL_TREELIST_SHEET_ID,&tmp_drinking->degustation_sheet_id,
                                    -1);
	
        xcave_debug_2str(__FUNCTION__,"degustation-sheet-id",25,ctime((time_t *)&tmp_drinking->degustation_sheet_id));

		strcpy(tmp_drinking->Note, pNote);
		strcpy(tmp_drinking->Commentaire, pCommentaire);
		g_free(pNote);
		g_free(pCommentaire);
	
		tmpVin->list_drinking = g_list_append(tmpVin->list_drinking, tmp_drinking);
	
		btreelist = gtk_tree_model_iter_next(treelist_drinking_model, &treelist_iter);
		tmpVin->qty -= tmp_drinking->qty;

		/*
		 * degustation sheet 
		 */
		GList              *tmp_list_ds;
		degustation_sheet  *tmp_ds;

        for(tmp_list_ds = list_ds; tmp_list_ds != NULL; tmp_list_ds = tmp_list_ds->next) {
            tmp_ds = g_malloc ( sizeof(degustation_sheet) );
            memset(tmp_ds,'\0',sizeof(degustation_sheet));
            memcpy(tmp_ds,tmp_list_ds->data,sizeof(degustation_sheet));
            if (tmp_ds->degustation_sheet_id == tmp_drinking->degustation_sheet_id) {
                tmpVin->list_degustation = g_list_append(tmpVin->list_degustation, tmp_ds);
		        /*
		         * if the degustation sheet exist before, it must be suppress before.
		         * The ds can exist if the drinking line was modified and not created.
		         */
		        GList              *tmp_list_full_ds;
		        degustation_sheet  *tmp_full_ds;
                tmp_full_ds = g_malloc ( sizeof(degustation_sheet) );
                for(tmp_list_full_ds = list_full_ds; tmp_list_full_ds != NULL; tmp_list_full_ds = tmp_list_full_ds->next) {
                    memset(tmp_full_ds,'\0',sizeof(degustation_sheet));
                    memcpy(tmp_full_ds,tmp_list_full_ds->data,sizeof(degustation_sheet));
                    if (tmp_full_ds->degustation_sheet_id == tmp_drinking->degustation_sheet_id) {
                        list_full_ds = g_list_remove_link(list_full_ds,tmp_list_full_ds);
			            g_list_free1(tmp_list_full_ds);
                        xcave_debug_msg_int(__FUNCTION__,"g_list_remove(list_full_ds) ok",5,g_list_length(list_full_ds));
			            break;
                    } else {
                        xcave_debug_msg_int(__FUNCTION__,"g_list_remove(list_full_ds) ko",5,g_list_length(list_full_ds));
                    }
		        }
                g_free(tmp_full_ds);
                list_full_ds = g_list_append(list_full_ds, tmp_ds);
		    }
		    else
              g_free(tmp_ds);
	        xcave_debug_msg_int(__FUNCTION__,"list_full_ds",2,g_list_length(list_full_ds));
		}
	}
	
	/*
	 * get data from vpaned 'comment'
	 */
	GtkWidget		*vincom;
	GtkTextBuffer	*buffer_vincom;
	GtkTextIter		start_vincom;
	GtkTextIter 	end_vincom;
	gchar			*comment;
	
	vincom 	= lookup_widget (window_detail, "vincom");
	buffer_vincom = gtk_text_view_get_buffer (GTK_TEXT_VIEW (vincom));

	gtk_text_buffer_get_start_iter(buffer_vincom,&start_vincom);
	gtk_text_buffer_get_end_iter(buffer_vincom,&end_vincom);
	
	comment = g_malloc(gtk_text_buffer_get_char_count(buffer_vincom) );
	comment = gtk_text_buffer_get_text(buffer_vincom, &start_vincom, &end_vincom, FALSE );

	strcpy(tmpVin->Commentaire,comment);
	g_free(comment);
	
	/*
	 * commentaire. Remplacement de tout les carateres <CR> par ² avant mise à jour du fichier stocks.
	 * le caractere <CR> indique un fin d'enregistrement dans un fichier stream.
	 */
	gint i;
	for ( i=0 ; i < (comment_size - 1) ; i++) 
		if (strncmp(&tmpVin->Commentaire[i], "\n",1) == 0) strncpy(&tmpVin->Commentaire[i],"²",1);

	/*
	 * drinking wine rate ... or whatever u want
	 */
	strcpy (tmpVin->Note,gtk_entry_get_text (GTK_ENTRY (lookup_widget (window_detail, "vinnote"))));

	/*
	 * coherency controls
	 */
	gboolean	check_ok = TRUE;
	
	if ( strlen (tmpVin->Nom)	== 0 && check_ok == TRUE ) {
		quick_message (_(" Wine name's missing "));
		check_ok = FALSE;
	}
	if (strlen (tmpVin->color) == 0 && check_ok == TRUE ) {
		quick_message (_(" Color's missing "));
		check_ok = FALSE;
	}
	if ( (tmpVin->vintage < 1800 || tmpVin->vintage > nowan) && check_ok == TRUE ) {
		quick_message (_(" Vintage year's error "));
		check_ok = FALSE;
	}
	if ( tmpVin->Conserv < 0 && check_ok == TRUE )  {
		quick_message (_(" Data number of year for conservation is false "));
		check_ok = FALSE;
	}
	if ( strlen (tmpVin->country)	== 0 && check_ok == TRUE ) {
		quick_message (_(" Country's missing "));
		check_ok = FALSE;
	}
	if ( strlen (tmpVin->Region)	== 0 && check_ok == TRUE ) {
		quick_message (_(" Region's missing "));
		check_ok = FALSE;
	}
	if ( strlen (tmpVin->Appellation) == 0 && check_ok == TRUE ) {
		quick_message (_(" Appellation's missing "));
		check_ok = FALSE;
	}

	/*
	 * gestion des doublons
	 */
	if ( (window_detail_origine == BUTTON_ADD || window_detail_origine == BUTTON_RACK_ADD)
		&&
		 (g_list_find_custom(list_stock,(gpointer) tmpVin,(GCompareFunc)find_existing_wine) != NULL) 
		&&
		 (check_ok == TRUE)
		) {
		quick_message (_("A wine with similar characteristic\n\tcountry\n\tregion\n\tappellation\n\tdomain\n\tvintage is already in the cellar"));
		check_ok = FALSE;
	}

	if (tmpVin->qty < g_list_length(tmpVin->list_emplacement) && check_ok == TRUE ) {
		quick_message (_(" More bottles in Emplacement than in the stocks "));
		check_ok = FALSE;
	}
	
	if (tmpVin->qty < 0 && check_ok == TRUE ) {
		quick_message (_(" You drink too much (more bottles drinking than purchase ! "));
		check_ok = FALSE;
	} 

	if ( 	check_ok == TRUE ) {

		 /* controle de la relation region/appellation 
			for(tmp_list_appellation = list_appellation; 
				tmp_list_appellation != NULL; 
				tmp_list_appellation = tmp_list_appellation->next) {
				  memcpy(&tmpApp,tmp_list_appellation->data,appellation_size);
				  if (  (  strcmp (data->Appellation, tmpApp.Appellation) == 0 
						&& strcmp (data->Region     , tmpApp.Region     ) != 0) 
					 || (  strcmp (data->Appellation, tmpApp.Appellation) == 0 
						&& strcmp (data->Region     , tmpApp.Region     ) != 0))
						   quick_message (_(" No such appellation for this region "));
		}
		if (tmp_list_appellation == (g_list_last(list_appellation)))
		{
		}
		*/

		/* Positionnement du flag 'maturite' */
        if (tmpVin->qty == 0)
     	    tmpVin->Maturite = -2000;
        else
            if (tmpVin->vintage ==0 || tmpVin->Conserv == 0) 
	       tmpVin->Maturite = -1000;
            else 
               tmpVin->Maturite=(100*(nowan-(tmpVin->vintage))/tmpVin->Conserv);

		switch(window_detail_origine) {
			case (BUTTON_ADD): /* creation d un nouveau vin*/  
				list_stock = g_list_append(list_stock ,tmpVin);
				list_stock = g_list_sort(list_stock,(GCompareFunc)cmp_stock);
		        window_detail_origine = NO_BUTTON;
                /*
                 * need to clean the list_ds
                 */
                xcave_debug_msg_int(__FUNCTION__,"list_ds",2,g_list_length(list_ds));
                list_ds = xcave_g_list_free(list_ds);
                xcave_debug_msg_int(__FUNCTION__,"list_ds",2,g_list_length(list_ds));
                break;
				
			case (BUTTON_RACK_ADD): /* creation d un nouveau vin*/
				list_stock = g_list_append(list_stock ,tmpVin);
				list_stock = g_list_sort(list_stock,(GCompareFunc)cmp_stock);
				/* window should be closed, list_append_rack should free data 
				   used by window_rack. We could possibly imagine open again
				   window_rack ... or redesign large amount of xcave (-; */
		        window_detail_origine = BUTTON_RACK;
				break;
	
			case (BUTTON_MODIF): /* modification d'un vin deja existant */
				/* identifier le vin qui a ete modifie */
	
				/* we need selected data  */
				Vin_rowSelected = xcave_id_selected_treelist_row();
	
				/*
				 * BEWARE - update of the data straight in the list_stock
				 * 			get a pointer on the glist element from COL_TREELIST_PDATA
				 *			of GtkTreeList TreeList
				 */
			
				/* Emplacement */
				/* liberer la liste precedente avant svp */
				Vin_rowSelected->list_emplacement = xcave_g_list_free(Vin_rowSelected->list_emplacement);
		
				/* Purchase */
				/* liberer la liste precedente avant svp */
				Vin_rowSelected->list_purchase = xcave_g_list_free(Vin_rowSelected->list_purchase);
				
				/* Drinking */
				/* liberer la liste precedente avant svp */
				Vin_rowSelected->list_drinking = xcave_g_list_free(Vin_rowSelected->list_drinking);
				
				list_stock = g_list_remove(list_stock, Vin_rowSelected);
				list_stock = g_list_append(list_stock ,tmpVin);
	
		        window_detail_origine = NO_BUTTON;
				break;
				
			case (BUTTON_RACK_MODIF):
				/* identifier le vin qui a ete modifie */
	
				/* we need selected data  */
				Vin_rowSelected = xcave_id_selected_toggledbutton();

				/* Emplacement */
				/* liberer la liste precedente avant svp */
				Vin_rowSelected->list_emplacement = xcave_g_list_free(Vin_rowSelected->list_emplacement);
		
				/* Purchase */
				/* liberer la liste precedente avant svp */
				Vin_rowSelected->list_purchase = xcave_g_list_free(Vin_rowSelected->list_purchase);
				
				/* Drinking */
				/* liberer la liste precedente avant svp */
				Vin_rowSelected->list_drinking = xcave_g_list_free(Vin_rowSelected->list_drinking);
	
				list_stock = g_list_remove(list_stock, Vin_rowSelected);
				list_stock = g_list_append(list_stock ,tmpVin);
				
				/* window should be closed, list_append_rack should free data 
				   used by window_rack. We could possibly imagine open again
				   window_rack ... or redesign large amount of xcave (-; */
		        window_detail_origine = BUTTON_RACK;
				break;
				
			case (BUTTON_DUPLICATE): /* creation d un nouveau vin*/  
				list_stock = g_list_append(list_stock ,tmpVin);
				list_stock = g_list_sort(list_stock,(GCompareFunc)cmp_stock);

		        window_detail_origine = NO_BUTTON;
				break;
				
			case (BUTTON_RACK_DUPLICATE): /* creation d un nouveau vin*/
				list_stock = g_list_append(list_stock ,tmpVin);
				list_stock = g_list_sort(list_stock,(GCompareFunc)cmp_stock);
				/* window should be closed, list_append_rack should free data 
				   used by window_rack. We could possibly imagine open again
				   window_rack ... or redesign large amount of xcave (-; */
		        window_detail_origine = BUTTON_RACK;
				break;
	
			default:
				break;
		}

		list_stock = g_list_sort(list_stock,(GCompareFunc)cmp_stock);
		xcave_xmlWrite(DBPATH);

		/*
		 * need to update storeview_xcave_wine_origin and storelist
		 */
		GtkWidget       *treelist;
		GtkWidget       *treeview;
		// 2.3.1 GtkListStore	*storelist;
		GtkTreeStore	*storelist;
		GtkTreeStore	*storeview_xcave_wine_origin;
	
		treelist = lookup_widget(window_xcave,"treeview_xcave_wine_information");
		// 2.3.1 storelist  = (GtkListStore *) gtk_tree_view_get_model((GtkTreeView *)treelist);
		storelist  = (GtkTreeStore *) gtk_tree_view_get_model((GtkTreeView *)treelist);
		// 2.3.1 gtk_list_store_clear(storelist);
		gtk_tree_store_clear(storelist);

		treeview = lookup_widget(window_xcave,"treeview_xcave_wine_origin");
		storeview_xcave_wine_origin	= (GtkTreeStore *) gtk_tree_view_get_model((GtkTreeView *)treeview);
		gtk_tree_store_clear(storeview_xcave_wine_origin);
	    
		xcave_fill_model (storeview_xcave_wine_origin, storelist);

		/*
		 * penser à mettre à jour la liste emplacement
		 */
		list_append_rack();
	
		ptmpCtg = g_malloc (sizeof(Categ));
		memset(ptmpCtg, '\0', sizeof( Categ ));
		strcpy(ptmpCtg->color,     tmpVin->color );
		strcpy(ptmpCtg->country,        tmpVin->country );
		strcpy(ptmpCtg->Region,      tmpVin->Region );
		strcpy(ptmpCtg->Appellation, tmpVin->Appellation );
	
		if (g_list_find_custom(list_categ,(gpointer) ptmpCtg,(GCompareFunc)find_categ) == NULL) {
 		   list_append_categ();
		}
	
		gtk_object_destroy (GTK_OBJECT (window_detail));

		if (window_detail_origine == BUTTON_RACK) {
	           GtkButton *button = NULL;     /* 2.3.2 */
                   gpointer   user_data = NULL;  /* 2.3.2 */

		   gtk_object_destroy (GTK_OBJECT (window_rack));
		   on_xcave_button_rack_clicked(button, user_data);
		}
		else
		   gtk_widget_set_sensitive(window_xcave, TRUE);
		
		/* 
		 * synthese update
		 */
        if (xcave_statusbar_id != 0) 
           gtk_statusbar_remove ((GtkStatusbar *)xcave_statusbar_v, xcave_statusbar_ctxtid, xcave_statusbar_id);

	    sprintf (xcave_statusbar_txt, _("Number of bottles in cellar : %d"), NbBottleStock);
        xcave_statusbar_id = gtk_statusbar_push ((GtkStatusbar *)xcave_statusbar_v, xcave_statusbar_ctxtid, xcave_statusbar_txt);
    } else {
		xcave_debug_msg(__FUNCTION__,"on_xcave_detail_button_ok_clicked:clean up the mess:\n");
		/* 
		 * suite à erreur de controle 
		 * liberation de la memoire allouee
		 */
		xcave_g_list_free(tmpVin->list_emplacement);
		xcave_g_list_free(tmpVin->list_drinking);
		xcave_g_list_free(tmpVin->list_purchase);
		g_free(tmpVin);
	}
    XCAVE_DEBUG_E;
}

/* 
 * GtkWindow 'detail_window'
 * button_add_cancel clicked
 */
void
on_xcave_detail_button_cancel_clicked (GtkButton * button,
		                               gpointer user_data)
{
    XCAVE_DEBUG_B;


	if (window_detail_origine == BUTTON_ADD || window_detail_origine == BUTTON_MODIF) {
		gtk_widget_set_sensitive(window_xcave, TRUE);
		window_detail_origine = NO_BUTTON;
	}
	else {
		gtk_widget_set_sensitive(window_rack, TRUE);
		/* we need selected data for gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (toggledbutton),FALSE); */
		Vin		*Vin_rowSelected;
		Vin_rowSelected = xcave_id_selected_toggledbutton();
		window_detail_origine = BUTTON_RACK;
	}

	gtk_object_destroy (GTK_OBJECT (window_detail));

	/*
	 * need to clean the list_ds (temporary degustation list)
	 */
        if (lDS != NULL) {
	   xcave_debug_msg(__FUNCTION__,"g_free(lDS)");
           // g_free(lDS);
           // lDS = NULL;
	}

	xcave_debug_msg_int(__FUNCTION__,"xcave_g_list_free(list_ds)",2,g_list_length(list_ds));
	list_ds = xcave_g_list_free(list_ds);

    XCAVE_DEBUG_E;
}

/* 
 * GtkWindow 'detail_window'
 * button_duplicate_clicked
 */
void
on_xcave_detail_button_duplicate_clicked(GtkButton       *button,
                                         gpointer         user_data)
{
    XCAVE_DEBUG_B;
	gtk_window_set_title(GTK_WINDOW (window_detail), _("Duplicate wine"));

	if (window_detail_origine == BUTTON_RACK_MODIF)
	  window_detail_origine = BUTTON_RACK_DUPLICATE;
	else
	  window_detail_origine = BUTTON_DUPLICATE;
	
	on_xcave_detail_button_ok_clicked(button, &user_data);
	
    XCAVE_DEBUG_E;
}

/*
 * GtkWindow 'detail'
 * destroy signal
 */
void
on_xcave_detail_destroy (GtkObject * object, gpointer user_data)
{
    XCAVE_DEBUG_B;

	/* 
	 * reactive window_xcave
	 */
	if (window_detail_origine == BUTTON_ADD || window_detail_origine == BUTTON_MODIF || window_detail_origine == BUTTON_DUPLICATE)
		gtk_widget_set_sensitive(window_xcave, TRUE);

    XCAVE_DEBUG_E;
}

void
on_xcave_detail_check_resize                 (GtkContainer    *container,
                                        gpointer         user_data)
{

   gint height = 0;
   gint width = 0;

   gdk_window_get_size( container->widget.window , &width, &height);

   sprintf(WindowsDetailWidth,"%d",width);
   sprintf(WindowsDetailHeight,"%d",height);
   
}

