/***************************************************************************
 *            xcave_fileselection.c
 *
 *  Mon Dec 13 22:19:24 2004
 *  Copyright  2004  Jean-Philippe Hergott
 *  xcave@free.fr
 ****************************************************************************/
 
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
  
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <errno.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

void
on_xcave_config_buttonfile_clicked   (GtkButton       *button,
                                        gpointer         user_data)
{
    XCAVE_DEBUG_B;
	
	xcave_fileselection_stock = create_xcave_fileselection_stock();
    
	gtk_file_chooser_set_filename(GTK_FILE_CHOOSER(xcave_fileselection_stock), DBPATH);
	// gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER (xcave_fileselection_stock), "/home/xcave");
    // gtk_file_chooser_set_current_name (GTK_FILE_CHOOSER (xcave_fileselection_stock), "xcave.xml");

    gtk_widget_show (xcave_fileselection_stock); 
    
    XCAVE_DEBUG_E;
}


void
on_xcave_fileselection_stock_destroy(GtkObject       *object,
                                        gpointer         user_data)
{
  gtk_object_destroy (GTK_OBJECT (xcave_fileselection_stock));

}

void
on_xcave_fileselection_stock_button_ok_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
	gchar *(buf) = (gchar *)gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (xcave_fileselection_stock));

	gtk_entry_set_text (GTK_ENTRY (lookup_widget (window_config, "PathStock")), (gchar *) buf);

	if (strcasecmp(buf, DBPATH) != 0){
		FILE *f;
	    if  ( (f = fopen (buf, "r")) == NULL) {
			/* 2.3.2 le fichier n'existe pas */
		    xcave_xmlWrite(buf);
		    strcpy(DBPATH,buf);
		  } else {
			/* 2.3.2 un fichier existe */
  			fclose(f);
		    strcpy(DBPATH,buf);
	        /*
	         * initialisation diverses et variees:
	         *   (GList) liste du stock
	         *   (GList) liste des country
	         *   (GList) liste des regions
	         *   (GList) liste des appellations
	         *   (GList) liste des cepages
	         */
		      list_append_stock();
		
		      list_append_rack();
		
		      list_append_categ();
		      list_append_country();
		      list_append_region();
		      list_append_appellation();
		      list_append_cepage();
		
		      list_country_append_stock();
		      list_region_append_stock();
		      list_appellation_append_stock();
		      list_cepage_append_stock();
	
		      list_country = g_list_sort(list_country,(GCompareFunc)cmp_country);
	
		      /*
		       * need to update storeview and storelist
		       */
		      GtkWidget		*treelist;
		      GtkWidget		*treeview;
		      GtkTreeStore	*storelist;
		      GtkTreeStore	*storeview;
		
		      treelist = lookup_widget(window_xcave,"treeview_xcave_wine_information");
		      storelist	= (GtkTreeStore *) gtk_tree_view_get_model((GtkTreeView *)treelist);
		      /* 2.3.1 gtk_list_store_clear(storelist);  */
		      gtk_tree_store_clear(storelist);
	
		      treeview = lookup_widget(window_xcave,"treeview_xcave_wine_origin");
		      storeview	= (GtkTreeStore *) gtk_tree_view_get_model((GtkTreeView *)treeview);
		      gtk_tree_store_clear(storeview);
		
		      xcave_fill_model (storeview, storelist);
		}
	}

	gtk_object_destroy (GTK_OBJECT (xcave_fileselection_stock));

}


void
on_xcave_fileselection_stock_button_cancel_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_object_destroy (GTK_OBJECT (xcave_fileselection_stock));

  printf(":%s:%d:\n",__FILE__,__LINE__);

}
