/*
 * Copyright (C) 2003 Jean-Philippe Hergott <hergott@free.fr>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <errno.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

gint
calculate_nb_bottle(gint type, gchar *lib)
{
  GList  *tmp_list_stock;
  Vin     tmpVin;
  gint    nb_calc = 0;
	
  for(tmp_list_stock = list_stock; tmp_list_stock != NULL ; tmp_list_stock = tmp_list_stock->next) {
      memcpy(&tmpVin,tmp_list_stock->data,sizeof(Vin));
	  switch (type) {
		  case CALCULATE_COLOR:
		       if (strcasecmp(tmpVin.color, lib) == 0)
				  nb_calc += tmpVin.qty;
		       break;
		  case CALCULATE_COUNTRY:
		       if (strcasecmp(tmpVin.country, lib) == 0)
				  nb_calc += tmpVin.qty;
		       break;
		  case CALCULATE_REGION:
		       if (strcasecmp(tmpVin.Region, lib) == 0)
				  nb_calc += tmpVin.qty;
		       break;
		  case CALCULATE_APPELATION:
		       if (strcasecmp(tmpVin.Appellation, lib) == 0)
				  nb_calc += tmpVin.qty;
		       break;		  
		  default:
			   break;
	  }
  }
  return(nb_calc);
}

gint
calculate_nb_bottle_in_rack(gint rack)
{
  gint         nb_bottle = 0;
  GList       *tmp_list_stock;
  GList       *tmp_list_rack;
  Vin          tmpVin;
  GList       *tmp_list_emplacement;
  Emplacement  tmpRack;
	
  for(tmp_list_stock = list_stock; 
	  tmp_list_stock != NULL ; 
	  tmp_list_stock = tmp_list_stock->next) {
	  printf(":%s:%d:%d:\n",__FILE__,__LINE__,nb_bottle);
      memcpy(&tmpVin,tmp_list_stock->data,sizeof(Vin));
      /* 2.4
	  if ( g_list_length(tmpVin.list_emplacement) != 0) {
		   printf(":%s:%d:%d:\n",__FILE__,__LINE__,nb_bottle);
			  for (tmp_list_rack = tmpVin.list_emplacement;
			   tmp_list_emplacement != NULL ;
			   tmp_list_emplacement = tmp_list_emplacement->next) {
			   printf(":%s:%d:%d:\n",__FILE__,__LINE__,nb_bottle);
				   tmpRack = g_malloc(sizeof(Emplacement));
				   memcpy(&tmpRack,tmp_list_emplacement->data,sizeof(Emplacement));
				   printf(":%s:%d:%d:\n",__FILE__,__LINE__,nb_bottle);
				   if (tmpRack.Rack == rack) nb_bottle++;
		  }
	  }
	  */
  }
  return(nb_bottle);
}
